add_printer("/account.php", function()
	pwd = get_session_state("pwd")
	table = [[
	<table  width=95%%  cellspacing=0 cellpadding=0>
		<tr><td style="color: white;" align=center bgcolor=blue><b>kolproxy Options</b></td></tr>
		<tr><td style="padding: 5px; border: 1px solid blue;">
			<center><table><tr><td>
				<p><a href="custom-settings?pwd=]] .. pwd .. [[">Change settings</a></p>
				<p><a href="http://kolproxy.houeland.com/" target="_blank">Open documentation in a new tab</a></p>
			</td></tr></table></center>
		</td></tr>
		<tr><td height=4></td></tr>
	</table>
	]]
	text = string.gsub(text, [[<span id="ro">]], "\n" .. table .. "%0")
end)

function make_buttons(valuestr, value, options)
	buttons = ""
	for _, v in pairs(options) do
		if value == v.value then
			buttons = buttons .. [[<input type="radio" name="]]..valuestr..[[" value="]] .. v.value .. [[" checked="yes">]] .. v.text
		else
			buttons = buttons .. [[<input type="radio" name="]]..valuestr..[[" value="]] .. v.value .. [[">]] .. v.text
		end
	end
	return buttons
end

add_printer("/custom-settings", function()
	pwd = get_session_state("pwd")
	settings = {
		{ title = "Automatically perform daily actions", set = "character", name = "automate daily visits", field = "option", values = { { value = "yes", text = "Yes" }, { value = "no", text = "No" }, { value = "aftercore", text = "Yes, and perform extra actions in aftercore" } } },
		{ title = "Custom skill used for automating combats", set = "character", name = "automate combat skill", field = "text", example = "Autoattack" },
		{ title = "Automate choice noncombats", set = "character", name = "automate choice noncombats", field = "yesno" },
		{ title = "Run automation scripts", set = "character", name = "run automation scripts", field = "yesno" },
		{ title = "Aftercore logout outfit", set = "character", name = "logout outfit", field = "text", example = "Rollover" },
		{ title = "Healing skill ID", set = "ascension", name = "healing skill", field = "number", example = "3012" },
		{ title = "Buffing outfit", set = "ascension", name = "buffing outfit", field = "text", example = "Buffing" },
		{ title = "Buffing outfit (when auto-healing)", set = "ascension", name = "autoheal buffing outfit", field = "text", example = "Buffing" },
	}
	settingstext = ""
	for idx, s in pairs(settings) do
		value = get_state(s.set, s.name)
		namestr = "name-" .. tostring(idx)
		valuestr = "value-" .. tostring(idx)
		if s.field == "text" then
			example = [[(e.g. <i>]] .. s.example .. [[</i>)]]
			item_text = s.title .. [[ = <input name="]]..valuestr..[[" value="]] .. value .. [[">]] .. example
		elseif s.field == "number" then
			example = [[(e.g. <i>]] .. s.example .. [[</i>)]]
			item_text = s.title .. [[ = <input name="]]..valuestr..[[" value="]] .. value .. [[">]] .. example
		elseif s.field == "yesno" then
			if value == "yes" then
				buttons = [[<input type="radio" name="]]..valuestr..[[" value="yes" checked="yes">Yes<input type="radio" name="]]..valuestr..[[" value="no">No]]
			elseif value == "no" then
				buttons = [[<input type="radio" name="]]..valuestr..[[" value="yes">Yes<input type="radio" name="]]..valuestr..[[" value="no" checked="yes">No]]
			else
				buttons = [[<input type="radio" name="]]..valuestr..[[" value="yes">Yes<input type="radio" name="]]..valuestr..[[" value="no">No]]
			end
			buttons = make_buttons(valuestr, value, { { value = "yes", text = "Yes" }, { value = "no", text = "No" } })
			item_text = s.title .. [[ = ]] .. buttons
		elseif s.field == "option" then
			buttons = make_buttons(valuestr, value, s.values)
			item_text = s.title .. [[ = ]] .. buttons
		else
			item_text = s.title .. [[ = <input name="]]..valuestr..[[" value="]] .. value .. [[">]]
		end
		this_text = [[<p>
		<input type="hidden" name="]]..namestr..[[" value="]] .. s.name .. [[">
		]] .. item_text .. [[
		<input type="hidden" name="stateset-]]..idx..[[" value="]] .. s.set .. [[">
</p>
]]
		settingstext = settingstext .. this_text
	end
	text = 	[[
	<table  width=95%%  cellspacing=0 cellpadding=0>
		<tr><td style="color: white;" align=center bgcolor=blue><b>kolproxy settings</b></td></tr>
		<tr><td style="padding: 5px; border: 1px solid blue;">
			<center><table><tr><td>
				<form action="custom-settings" method="post">
					]] .. settingstext .. [[
					<input type="hidden" name="pwd" value="]] .. pwd .. [["><input type="hidden" name="action" value="set state">
					<input type="submit">
				</form>
			</td></tr></table></center>
		</td></tr>
		<tr><td height=4></td></tr>
	</table>
	<table  width=95%%  cellspacing=0 cellpadding=0>
		<tr><td style="color: white;" align=center bgcolor=blue><b>Server settings</b></td></tr>
		<tr><td style="padding: 5px; border: 1px solid blue;">
			<center><table><tr><td>
				<form action="custom-store-settings" method="post">
					<input type="hidden" name="pwd" value="]] .. pwd .. [[">
					<input type="submit" value="Store kolproxy settings on server">
				</form>
				<form action="custom-load-settings" method="post">
					<input type="hidden" name="pwd" value="]] .. pwd .. [[">
					<input type="submit" value="Load kolproxy settings from server">
				</form>
			<tr><td><center><a href="account.php">Back to Account Menu</a></center></td></tr>
			</td></tr></table></center>
		</td></tr>
		<tr><td height=4></td></tr>
	</table>
	]]
	text = [[
		<html>
		<head>
			<link rel="stylesheet" type="text/css" href="http://images.kingdomofloathing.com/styles.css">
		</head>
		<body>]] .. text .. [[
		</body>
		</html>]]
--~ 	print("params", params)
end)
