add_printer("/cave.php", function()
	function select_item(name)
		if string.match(text, name) then
			text = string.gsub(text, "(<option value='[0-9]-' descid='[0-9]-')(>"..name.." %([0-9]-%)</option>)", "%1 selected=\"selected\"%2")
		else
			text = string.gsub(text, "(%-select an item%-)", "%1 {need: " .. name .. "}")
		end
	end

	if string.find(text, "depicts an angry%-looking man holding a spear and shield") then -- muscle
		select_item("viking helmet")
	end
	if string.find(text, "depicts a man fighting a crowd of little tiny people.") then -- mysticality
		select_item("stalk of asparagus")
	end
	if string.find(text, "depicts a pair of hands with little lines radiating off of them.") then -- moxie
		select_item("dirty hobo gloves")
	end

	if string.find(text, "with little round things pouring out of it") then -- muscle
		select_item("insanely spicy bean burrito")
	end
	if string.find(text, "small round glowing thing") then -- mysticality
		select_item("insanely spicy enchanted bean burrito")
	end
	if string.find(text, "little wiggly lines coming off of them") then -- moxie
		select_item("insanely spicy jumping bean burrito")
	end

	if string.find(text, "coiled snake with the head of a clown") then -- seal clubber
		select_item("clown whip")
	end
	if string.find(text, "large circle with a jeering clown head") then -- turtle tamer
		select_item("clownskin buckler")
	end
	if string.find(text, "long wavy horizontal lines") then -- pastamancer
		select_item("boring spaghetti")
	end
	if string.find(text, "a wobbly blob") then -- sauceror
		select_item("tomato juice of powerful power")
	end
	if string.find(text, "a group of small squares, and a large circle") then -- disco bandit
		text = string.gsub(text, "is in the wall next to the engraving.", [[%0<br><span style="color: green">{Need advanced cocktailcrafting drink.}</span>]])
	end
	if string.find(text, "wobbly shapes that sort of look like cutlets of meat") then -- accordion thief
		text = string.gsub(text, "Unexpectedly, you can't find any hole in the wall this time. Hmm.", [[%0<br><span style="color: green">{Need Polka of Plenty buff.}</span>]])
	end

	if string.find(text, "SPEAK THE PASSWORD TO ENTER") then
		tbl = get_ascension_state("zone.cave.paper strips")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		right_sides = {}
		left_sides = {}
		strips = {}
		count = 0
		for a,b in pairs(tbl) do
			right_sides[b.right] = a
			left_sides[b.left] = a
			count = count + 1
		end
		if count == 8 then
			where = nil
			for a,b in pairs(left_sides) do
				if right_sides[a] == nil then
					where = b
				end
			end
			solution = ""
			while where do
				solution = solution .. tbl[where].word
				where = left_sides[tbl[where].right]
			end
			text = string.gsub(text, "(<input type=\"text\" name=\"say\" size=\"30\")( />)", "%1 value=\""..solution.."\"%2")
		end
		text = string.gsub(text, "This could be an excellent opportunity to voice your opinion on any grievances you might have.</p>", "%0<p>" .. count .. "/8 strips found.</p>")
	end
end)

add_processor("/desc_item.php", function()
	name, left, right, word = string.match(text, "<b>(a [a-z]- paper strip)</b>.-title=\"A ([a-z-]-) tear\".-title=\"A ([a-z-]-) tear\".-<font size=%+1><b>([A-Z]-)</b></font>")
	if name and left and right and word then
		tbl = get_ascension_state("zone.cave.paper strips")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		tbl[name] = { left=left, right=right, word=word }
		set_ascension_state("zone.cave.paper strips", table_to_str(tbl))
	end
end)

-- Turtle Tamer

add_processor("/fight.php", function()
	if monster_name == "a guard turtle" then
		if string.match(text, "<img id='monpic' .-frenchturtle.gif.->") then
			set_fight_state("guard turtle.type", "French")
		end
	end
end)

--~ 	register_combat_skill("Tame French turtle", function(skills)
--~ 		if get_fight_state("guard turtle.type") == "French" and skills["Apprivoisez la tortue"] then
--~ 			return "Apprivoisez la tortue"
--~ 		end
--~ 	end)

-- Disco Bandit

add_processor("/fight.php", function()
	dancers = {
		["a breakdancing raver"] = "spinning his legs",
		["a pop-and-lock raver"] = "spastic and jerky",
		["a running man"] = "running anywhere",
	}
	if dancers[monster_name] then
		if get_fight_state("nemesis.dancer") == "" then
			set_fight_state("nemesis.dancer", "yes")
		end
		if string.find(text, dancers[monster_name]) then
			set_fight_state("nemesis.dancer.special move", "yes")
		else
			set_fight_state("nemesis.dancer.special move", "")
		end
		if string.find(text, "You lazily wave your hands around for a moment.") then
			set_fight_state("nemesis.dancer", "learned")
		end
	end
end)

--~ 	register_combat_skill("Learn dance move", function(skills)
--~ 		if get_fight_state("nemesis.dancer.special move") == "yes" then
--~ 			if get_fight_state("nemesis.dancer") ~= "learned" then
--~ 				if skills["Gothy Handwave"] then
--~ 					return "Gothy Handwave"
--~ 				end
--~ 			end
--~ 		end
--~ 	end)


-- Volcano

add_processor("/volcanomaze.php", function ()
--~ 	set_ascension_state("zone.volcano.maze states", table_to_str({}))
	platforms = {}
	goal = nil
	you = nil

	tbl = get_ascension_state("zone.volcano.maze states")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end

	squares = get_session_state("zone.volcano.maze squares")
	if (squares == "") then squares = {} else squares = str_to_table(squares) end

	for square, pos in string.gmatch(text, [[<div id="sq([0-9]+)" class="[^"]-" rel="([0-9,]+)">]]) do
		squares[tonumber(square)] = pos
	end

	set_session_state("zone.volcano.maze squares", table_to_str(squares))

--~ 	print("volcano text", text)
	if string.match(text, "A Volcanic Cave") then
		for pos, object in string.gmatch(text, [[<a href="%?move=[0-9]+,[0-9]+" title="%(([0-9,]+) %- ([^)]-)%)">]]) do
			if object == "Platform" then
				table.insert(platforms, pos)
			elseif object == "You" then
				you = pos
			elseif object == "Goal" then
				goal = pos
				table.insert(platforms, pos)
			end
		end
	else
		you = string.match(text, [["pos":"([0-9,]+)"]])
		showstr = string.match(text, [["show":(%b[])]])
		if showstr then
			for s in string.gmatch(showstr, [[([0-9]+)]]) do
				pos = squares[tonumber(s)]
				table.insert(platforms, pos)
			end
		end
	end

--~ 	print("this one is", printstr(platforms), goal, you)
	platformstr = table_to_str(platforms)
	isnew = true
	for x,y in pairs(tbl) do
		if str_to_table(y).platforms == platformstr then
			isnew = false
		end
	end
	if isnew and you then
		table.insert(tbl, table_to_str({ you = you, platforms = platformstr }))
		set_ascension_state("zone.volcano.maze states", table_to_str(tbl))
	end
end)

add_printer("/volcanomaze.php", function ()
	if string.match(text, "A Volcanic Cave") then
		local tbl = get_ascension_state("zone.volcano.maze states")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		if table.maxn(tbl) == 5 then
			text = string.gsub(text, [[value="Swim Back to Shore".->]], [[%0<br><a href="automate-volcanomaze" style="color:green">{Solve}</a>]])
		else
			text = string.gsub(text, [[value="Swim Back to Shore".->]], [[%0<br>{Explore the maze (5+ steps, then swim back or reload the page) to enable solving}]])
		end
	end
end)
